"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.create = void 0;
const fs = __importStar(require("fs"));
const logger = __importStar(require("./logger"));
exports.create = ({ git, repoConfig, protocol, workingDir }) => {
    return {
        setup: async () => {
            await git.clone({
                owner: repoConfig.owner,
                repo: repoConfig.repo,
                branch: repoConfig.branch,
                baseUrl: repoConfig.baseUrl,
                baseSshUrl: repoConfig.baseSshUrl,
                protocol: protocol,
                outputDir: workingDir,
                cwd: process.cwd(),
            });
        },
        isClean: async () => {
            const { stdout } = await git.getStatus();
            return !!stdout.match(/nothing to commit, working tree clean/);
        },
        save: () => git.addAll(),
        commit: (message = "chore: update data") => git.commit(message),
        push: (branch = "origin") => git.push(branch, repoConfig.branch),
        clear: () => {
            fs.unlinkSync(workingDir);
            logger.log(`Delete: ${workingDir}`);
        },
    };
};
